//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

const int CensusDataYearsMax = 13;  // # of years with population data
const int BrazilStateMax = 27; // # of Brazil States + Brasilia


const char* CensusYearArray[] = {
	"1872","1890","1900","1920",
	"1940","1950","1960","1970",
	"1980","1991","2000","2010",
	"2020" };

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if (Button1->Caption == "Start Viz") {
		CensusYearIndex = 0;
		QueryBrazilDatabase();
		Timer1->Interval = SpinEdit1->Value * 1000;
		Timer1->Enabled = true;
		Button1->Caption = "Stop Viz";
	} else {
		Timer1->Enabled = false;
		Button1->Caption = "Start Viz";
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
	// rotate through the census years - wrap around at end
	if (CensusYearIndex == CensusDataYearsMax-1) {
		CensusYearIndex = 0;
	} else {
		CensusYearIndex++;
	}
	QueryBrazilDatabase();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
	CensusYearIndex = 0;
}
//---------------------------------------------------------------------------

void TForm1::QueryBrazilDatabase()
{
	IBQuery1->Close();
	IBQuery1->ParamByName("CensusYear")->Value = CensusYearArray[CensusYearIndex];
	IBQuery1->Open();
	Label1->Caption = CensusYearArray[CensusYearIndex];
	IBQuery1->First();
	Series1->YValues->ValueSource = "POPULATION";
	Series1->XLabelsSource = "STATE_ABBREVIATION";
	Series1->DataSource = IBQuery1;
	Series1->CheckDataSource();
}



