unit Unit2;

interface

uses
  SysUtils, Types, UITypes, Classes, Variants, FMX.Types, FMX.Controls, FMX.Forms,
  FMX.Dialogs, FMX.Layouts, FMX.Memo, FMX.Edit, FMX.StdCtrls;

type
  TForm2 = class(TForm)
    StyleBook1: TStyleBook;
    Edit1: TEdit;
    ScaledLayout1: TScaledLayout;
    procedure FormCreate(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
  private
    { Private declarations }
    procedure DoMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Single);
    procedure DoMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Single);
    procedure DoClick(Sender: TObject);
  public
    { Public declarations }
    Cancelled : Boolean;
  end;

var
  Form2: TForm2;

implementation

{$R *.fmx}

type
  TKeyStyle = (ksBlack, ksGray, ksBrown, ksOrange);

  TKey = record
    X, Y    : Integer;
    Style   : TKeyStyle;
    Text    : String;
    Output  : String;
    Text2   : String;
    Output2 : String;
    Wide    : Boolean;
    Tall    : Boolean;
    Func    : procedure;
    Button  : TButton;
  end;

procedure Do2nd; forward;
procedure DoClear; forward;
procedure DoDelete; forward;
procedure DoDone; forward;
procedure DoCancel; forward;

const
  NrOfKeys = 39;

var
  Keys : array [1..NrOfKeys] of TKey = (
    (X: 0; Y: 0; Style: ksGray; Text: '2nd'; Func: Do2nd),
    (X: 1; Y: 0; Style: ksGray; Text: '('; Output: '('),
    (X: 2; Y: 0; Style: ksGray; Text: ')'; Output: ')'),

    (X: 3; Y: 0; Style: ksBlack; Text: 'X'; Output: 'x'),
    (X: 3; Y: 1; Style: ksBlack; Text: 'Z'; Output: 'z'),

    (X: 0; Y: 1; Style: ksGray; Text: '1/x'; Output: '1/('),
    (X: 1; Y: 1; Style: ksGray; Text: 'x^2'; Output: 'sqr('),
    (X: 2; Y: 1; Style: ksGray; Text: '^'; Output: '^'),

    (X: 0; Y: 2; Style: ksGray; Text: 'x!'; Output: '!'),
    (X: 1; Y: 2; Style: ksGray; Text: 'sqrt'; Output: 'sqrt('),
    (X: 2; Y: 2; Style: ksGray; Text: 'log'; Output: 'log('),

    (X: 0; Y: 3; Style: ksGray; Text: 'sin'; Output: 'sin('; Text2: 'arcsin'; Output2: 'arcsin('),
    (X: 1; Y: 3; Style: ksGray; Text: 'cos'; Output: 'cos('; Text2: 'arccos'; Output2: 'arccos('),
    (X: 2; Y: 3; Style: ksGray; Text: 'tan'; Output: 'tan('; Text2: 'arctan'; Output2: 'arctan('),

    (X: 0; Y: 4; Style: ksGray; Text: 'sinh'; Output: 'sinh('; Text2: 'arcsinh'; Output2: 'arcsinh('),
    (X: 1; Y: 4; Style: ksGray; Text: 'cosh'; Output: 'cosh('; Text2: 'arccosh'; Output2: 'arccosh('),
    (X: 2; Y: 4; Style: ksGray; Text: 'tanh'; Output: 'tanh('; Text2: 'arctanh'; Output2: 'arctanh('),

    (X: 3; Y: 2; Style: ksGray; Text: 'ln'; Output: 'ln('; Text2: 'log2'; Output2: 'log2('),
    (X: 3; Y: 3; Style: ksGray; Text: 'Pi'; Output: 'Pi'),
    (X: 3; Y: 4; Style: ksGray; Text: 'e^x'; Output: 'exp('; Text2: '2^x'; Output2: '2^('),

    (X: 4; Y: 1; Style: ksBlack; Text: '7'; Output: '7'),
    (X: 5; Y: 1; Style: ksBlack; Text: '8'; Output: '8'),
    (X: 6; Y: 1; Style: ksBlack; Text: '9'; Output: '9'),
    (X: 4; Y: 2; Style: ksBlack; Text: '4'; Output: '4'),
    (X: 5; Y: 2; Style: ksBlack; Text: '5'; Output: '5'),
    (X: 6; Y: 2; Style: ksBlack; Text: '6'; Output: '6'),
    (X: 4; Y: 3; Style: ksBlack; Text: '1'; Output: '1'),
    (X: 5; Y: 3; Style: ksBlack; Text: '2'; Output: '2'),
    (X: 6; Y: 3; Style: ksBlack; Text: '3'; Output: '3'),
    (X: 4; Y: 4; Style: ksBlack; Text: '0'; Output: '0'; Wide: True),
    (X: 6; Y: 4; Style: ksBlack; Text: '.'; Output: '.'),

    (X: 4; Y: 0; Style: ksBrown; Text: 'C'; Func: DoDelete),
    (X: 5; Y: 0; Style: ksBrown; Text: 'AC'; Func: DoClear),
    (X: 6; Y: 0; Style: ksBrown; Text: '/'; Output: '/'),
    (X: 7; Y: 0; Style: ksBrown; Text: '*'; Output: '*'),
    (X: 7; Y: 1; Style: ksBrown; Text: '-'; Output: '-'),
    (X: 7; Y: 2; Style: ksBrown; Text: '+'; Output: '+'),

    (X: 7; Y: 3; Style: ksOrange; Text: 'DONE'; Func: DoDone),
    (X: 7; Y: 4; Style: ksOrange; Text: 'CNCL'; Func: DoCancel)
  );

var
  Is2nd : Boolean = False;

procedure Do2nd;
var
  i : Integer;
begin
  Is2nd := not Is2nd;
  for i := 1 to NrOfKeys do
    if Is2nd and (Keys[i].Text2 <> '') then
      Keys[i].Button.Text := Keys[i].Text2
    else
      Keys[i].Button.Text := Keys[i].Text;
end;

procedure DoClear;
begin
  Form2.Edit1.Text := '';
end;

procedure DoDelete;
begin
  Form2.Edit1.Text := Copy(Form2.Edit1.Text,1,Length(Form2.Edit1.Text)-1);
end;

procedure DoDone;
begin
  Form2.Close;
end;

procedure DoCancel;
begin
  Form2.Cancelled := True;
  Form2.Close;
end;

procedure TForm2.DoClick(Sender: TObject);
var
  B : TButton;
begin
  B := Sender as TButton;
  if Is2nd and (Keys[B.Tag].Text2 <> '') then
      Edit1.Text := Edit1.Text+Keys[B.Tag].Output2
  else
    Edit1.Text := Edit1.Text+Keys[B.Tag].Output;
  if Assigned(Keys[B.Tag].Func) then
    Keys[B.Tag].Func;
end;

procedure TForm2.DoMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
var
  B : TButton;
begin
  B := (Sender as TButton);
  case Keys[B.Tag].Style of
    ksGray   : B.StyleLookup := 'buttondownstylegray';
    ksBlack  : B.StyleLookup := 'buttondownstyleblack';
    ksBrown  : B.StyleLookup := 'buttondownstylebrown';
    ksOrange : B.StyleLookup := 'buttondownstyleorange';
  end;
end;

procedure TForm2.DoMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
var
  B : TButton;
begin
  B := (Sender as TButton);
  case Keys[B.Tag].Style of
    ksGray   : B.StyleLookup := 'buttonupstylegray';
    ksBlack  : B.StyleLookup := 'buttonupstyleblack';
    ksBrown  : B.StyleLookup := 'buttonupstylebrown';
    ksOrange : B.StyleLookup := 'buttonupstyleorange';
  end;
end;

procedure TForm2.Edit1KeyDown(Sender: TObject; var Key: Word; var KeyChar: Char;
  Shift: TShiftState);
begin
  if Key = 13 then
    Keys[1].Button.SetFocus;
end;

procedure TForm2.FormCreate(Sender: TObject);
var
  B : TButton;
  i : Integer;
begin
  for i := 1 to NrOfKeys do begin
    B := TButton.Create(Self);
    B.Parent := ScaledLayout1;
    case Keys[i].Style of
      ksGray   : B.StyleLookup := 'buttonupstylegray';
      ksBlack  : B.StyleLookup := 'buttonupstyleblack';
      ksBrown  : B.StyleLookup := 'buttonupstylebrown';
      ksOrange : B.StyleLookup := 'buttonupstyleorange';
    end;
    B.Position.X := 2+60*Keys[i].X;
    if Keys[i].Wide then
      B.Width := 118
    else
      B.Width := 58;
    B.Position.Y := 24+46+44*Keys[i].Y;
    if Keys[i].Tall then
      B.Height := 80
    else
      B.Height := 36;
    B.OnMouseDown := DoMouseDown;
    B.OnMouseUp := DoMouseUp;
    B.OnClick := DoClick;
    B.Text := Keys[i].Text;
    B.Font.Size := 14;
    B.Font.Style := [TFontStyle.fsBold];
    B.Tag := i;
    Keys[i].Button := B;
  end;
end;

procedure TForm2.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  Keys[1].Button.SetFocus; // Hides keyboard as well
end;

end.
